#==============================================================================:x
#
#
#    makefile
#
#    hal/mpc555/arch/src
#
#==============================================================================

PACKAGE       := hal_mpc555
include ../../../../../pkgconf/pkgconf.mak

LIBRARY       := libtarget.a
COMPILE       := hal_misc.c context.S immr.S mpc555_stub.c start.S hal_isrdispatch.cxx \
                 tb_isrdispatch.cxx initisrsys.c pit_isrdispatch.cxx rtc_isrdispatch.cxx \
                 pll_isrdispatch.cxx imb3_isrdispatch.cxx imb3_isrsource.cxx \
                 quadc_isrsource.cxx mios_isrsource.cxx qsci_isrsource.cxx \
                 toucan_isrsource.cxx tpu_isrsource.cxx mpc555_isrsys.cxx
OTHER_OBJS    :=
OTHER_TARGETS := vectors.stamp ldscript.stamp
OTHER_DEPS    := $(PACKAGE)_vectors.d ldscript.d
OTHER_CLEAN   := vectors.clean ldscript.clean

include $(COMPONENT_REPOSITORY)/pkgconf/makrules.src

.PHONY: ldscript.clean

vectors.stamp: $(PACKAGE)_vectors.o
	$(CP) $< $(PREFIX)/lib/vectors.o
	@$(TOUCH) $@

vectors.clean:
	$(RM) $(PREFIX)/lib/vectors.o $(PACKAGE)_vectors.o
	$(RM) vectors.stamp

$(PACKAGE)_vectors.o: $(BUILD_TREE)/pkgconf/pkgconf.mak \
    $(BUILD_TREE)/pkgconf/makevars $(PACKAGE_RULES_FILE)

ldscript.stamp: mpc555.ld
	$(CC) -E -P -Wp,-MD,ldscript.tmp -DEXTRAS=1 -xc $(INCLUDE_PATH) $(CFLAGS) -o $(PREFIX)/lib/target.ld $<
	@echo > ldscript.d
	@echo $@ ':' $< '\' >> ldscript.d
	@tail -n +2 ldscript.tmp >> ldscript.d
	@rm ldscript.tmp
	$(TOUCH) $@

ldscript.clean:
	$(RM) -f $(PREFIX)/lib/target.ld
	$(RM) -f ldscript.stamp

