#ifndef INITISRSYS_C
#define INITISRSYS_C

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <cyg/hal/initisrsys.h>
#include <cyg/hal/hal_intr.h>
#include <pkgconf/hal.h>

//------------------------
// Function implementation
//------------------------
#if defined(CYG_HAL_STARTUP_RAM)
externC cyg_uint32 hal_default_isr(CYG_ADDRWORD, CYG_ADDRWORD);
externC void __default_interrupt_vsr(void);

#if defined(CYGDBG_HAL_DEBUG_GDB_BREAK_SUPPORT)
#include <cyg/hal/mpc555_stub.h>
externC int cyg_hal_gdb_isr(target_register_t pc);
#endif

void initISRSystem(void)
{
  // Replace the monitor isr's by the code's isr's. This is necessary because
  // the monitor isr's will not have kernel support, plus, it makes debuggging
  // a lot easier.
  int i;
  for(i = 0; i < CYGNUM_HAL_ISR_COUNT; i++)
    hal_interrupt_handlers[i] = (CYG_ADDRESS)hal_default_isr;

#if defined(CYGDBG_HAL_DEBUG_GDB_BREAK_SUPPORT)
  hal_interrupt_handlers[CYGNUM_HAL_ISR_COUNT] = (CYG_ADDRESS)cyg_hal_gdb_isr;
#endif

  // Allow for kernel support for interrupts
  hal_vsr_table[5] = (CYG_ADDRESS)__default_interrupt_vsr;
  hal_vsr_table[9] = (CYG_ADDRESS)__default_interrupt_vsr;
}
#endif // if defined(CYG_HAL_STARTUP_RAM)

#endif // INITISRSYS_C
