#ifndef QUADC_ISRSOURCE_CXX
#define QUADC_ISRSOURCE_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/hal/quadc_isrsource.h"

#if !defined(CYG_HAL_STARTUP_STUBS) && defined(CYG_HAL_MPC555)
#include "cyg/hal/imb3_isrdispatch.h"
#include "cyg/infra/cyg_ass.h"

//-------------------------------------
// Public constructor(s) and destructor
//-------------------------------------
QUADC_isrSource::QUADC_isrSource(IMB3_isrDispatcher * a_dispatcher,
                                 unsigned char a_isrpriority_queue1,
                                 unsigned char a_isrpriority_queue2,
                                 QUADC_isrSource::QUADC_IDENTITY a_identity)
    : IMB3_isrSource(a_dispatcher),
      m_priority_queue1(a_isrpriority_queue1),
      m_priority_queue2(a_isrpriority_queue2),
      m_identity(a_identity)
{
  CYG_ASSERT(a_isrpriority_queue1 != a_isrpriority_queue2, "Different isr sources on same priority");
  a_dispatcher->attachToPriority(this, a_isrpriority_queue1);
  a_dispatcher->attachToPriority(this, a_isrpriority_queue2);
}

// Provide an (empty) virtual destructor
QUADC_isrSource::~QUADC_isrSource()
{
}

//------------------------
// Public member functions
//------------------------
// findInterruptingVector
cyg_uint32 QUADC_isrSource::findInterruptingVector(unsigned char a_priority)
{
  return 0;
}

// enableInterrupts
void QUADC_isrSource::enableInterrupts(void)
{
  
}

// disableInterrupts
void QUADC_isrSource::disableInterrupts(void)
{
  
}
#endif // if !defined ...

#endif // QUADC_ISRSOURCE_CXX
