//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <cyg/io/io.h>
#include <cyg/io/ttyio.h>
#include <cyg/io/config_keys.h>

#include <stdio.h>

//------------------------
// This is the entry point
//------------------------
int main(void)
{
  char rx_buffer[255];
  cyg_uint32 rx_len = 1;

  Cyg_ErrNo error;
  cyg_io_handle_t dev_handle = 0;

  // This should fail, /dev/tty1 is not included in the build
  error = cyg_io_lookup("/dev/tty1", &dev_handle);
  if(error)
    // This should go fine
    error = cyg_io_lookup("/dev/tty2", &dev_handle);

  if(!error)
  { // configure the device
    cyg_tty_info_t config;
    config.tty_out_flags = (CYG_TTY_OUT_FLAGS_CRLF);
    config.tty_in_flags  = (CYG_TTY_IN_FLAGS_CR | CYG_TTY_IN_FLAGS_ECHO);
    cyg_uint32 len = sizeof(config);

    error = cyg_io_set_config(dev_handle, CYG_IO_SET_CONFIG_TTY_INFO, &config, &len);
  }

  // Now go on reading characters and echoing them back
  int count = 10;
  while(!error && count)
  { // read one character and echo it back
    rx_len = 1;
    error = cyg_io_read(dev_handle, rx_buffer, &rx_len);
    count--;
  }

  printf("Hello world\n");

  return error;
}
