#ifndef KINTERRUPT_H
#define KINTERRUPT_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <cyg/kernel/kapi.h>

//-----------------
// Type definitions
//-----------------
typedef cyg_vector_t   KInterruptVector;
typedef cyg_priority_t KInterruptPriority;

//------------------
// Class declaration
//------------------
class KInterrupt : public cyg_interrupt
{
  public:
    typedef enum {
      Complete = CYG_ISR_HANDLED,
      Partial  = CYG_ISR_CALL_DSR } KInterruptStatus;
      
                                KInterrupt(KInterruptVector a_vector, 
                                           KInterruptPriority a_priority);
    virtual                     ~KInterrupt();

    void                        mask(void);
    void                        unmask(void);

  protected:
    virtual KInterruptStatus    isr(void) = 0;
    virtual void                dsr(unsigned long a_count) = 0;
    void                        acknowledge(void);

  private:
    static unsigned int         s_isr(KInterruptVector a_vector, void * a_data);
    static void                 s_dsr(KInterruptVector a_vector, unsigned long a_count, void * a_data);

    cyg_handle_t                m_handle;
    KInterruptVector            m_vector;
};

#endif // KINTERRUPT_H
