#ifndef KDELAY_CXX
#define KDELAY_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/kal/kdelay.h"
#include <cyg/kernel/kapi.h>
#include <math.h>

//---------------------
// Class implementation
//---------------------
// Constructor
KDelay::KDelay(unsigned int a_milisecs)
{
  cyg_thread_delay(convertToTicks(a_milisecs));
}

// Provide an (empty) virtual destructor
KDelay::~KDelay()
{
}

// convertToTicks
unsigned int KDelay::convertToTicks(unsigned int a_milisecs)
{
  cyg_handle_t rtc = cyg_real_time_clock();
  cyg_resolution_t res = cyg_clock_get_resolution(rtc);

  float tmp = ((1000000.0 * res.divisor) / res.dividend);
  unsigned int result = (unsigned int)ceil(a_milisecs * tmp);

  return (result ? result : 1);
}

#endif // KDELAY_CXX
