#ifndef KTIMERBASE_CXX
#define KTIMERBASE_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "ktimerbase.h"

//---------------------
// Class implementation
//---------------------
// Constructor
KTimerBase::KTimerBase(unsigned int a_priority, 
                       char * a_name, 
                       void * a_stack, 
                       size_t a_stacksize,
                       KClockTickGenerator * a_clock)
    : KThread(a_priority, a_name, a_stack, a_stacksize),
      m_clock(a_clock)
{
  resume();
}

// Destructor
KTimerBase::~KTimerBase()
{
  suspend();
}

// threadEntry
void KTimerBase::threadEntry(void)
{
  KSingleLock sl(&m_cond);
  KTimer * a_timer;

  for(;;)
  {
    sl.lock();

    while((a_timer = m_timers.remove()))
      a_timer->timeout();
  }
}

#endif // KTIMERBASE_CXX
