#include <cyg/kernel/kapi.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* now declare (and allocate space for) some kernel objects,
   like the two threads we will use */
cyg_thread thread_s[2];		/* space for two thread objects */
char stack[2][4096];		/* space for two 4K stacks */

/* now the handles for the threads */
cyg_handle_t simple_threadA, simple_threadB;

/* and now variables for the procedure which is the thread */
cyg_thread_entry_t simple_program;

/* and now a mutex to protect calls to the C library */
cyg_mutex_t cliblock;
cyg_cond_t  clibcond;

/* we install our own startup routine which sets up threads */
int main(void)
{
  printf("Entering twothreads' main() function\n");

  cyg_mutex_init(&cliblock);
  cyg_cond_init(&clibcond, &cliblock);

  cyg_cond_signal(&clibcond);
  cyg_cond_signal(&clibcond);
  cyg_cond_signal(&clibcond);
  cyg_cond_signal(&clibcond);
  cyg_cond_signal(&clibcond);

  cyg_thread_create(4, simple_program, (cyg_addrword_t) 0,
		    "Thread A", (void *) stack[0], 4096,
		    &simple_threadA, &thread_s[0]);
  cyg_thread_create(4, simple_program, (cyg_addrword_t) 1,
		    "Thread B", (void *) stack[1], 4096,
		    &simple_threadB, &thread_s[1]);

  cyg_thread_resume(simple_threadA);
  cyg_thread_resume(simple_threadB);

  for(;;) 
  {
    cyg_thread_delay(100);
    printf("Delay ended\n");
    cyg_cond_broadcast(&clibcond);
  }
}

/* this is a simple program which runs in a thread */
void simple_program(cyg_addrword_t data)
{
  for(;;)
  {
    cyg_cond_wait(&clibcond);
    printf("Condition released\n");
  }
}
